diff --git a/src/qmplay2/opengl/OpenGLCommon.cpp b/src/qmplay2/opengl/OpenGLCommon.cpp
index 9dfc9563..3ad1d289 100644
--- a/src/qmplay2/opengl/OpenGLCommon.cpp
+++ b/src/qmplay2/opengl/OpenGLCommon.cpp
@@ -26,17 +26,12 @@
 #include <Frame.hpp>
 #include <Functions.hpp>
 
-#include <QOffscreenSurface>
-#include <QOpenGLContext>
-#include <QOpenGLShader>
+#include <QtOpenGL/QGLShader>
 #include <QResizeEvent>
 #include <QResource>
 #include <QPainter>
 #include <QLibrary>
 #include <QWidget>
-#ifdef Q_OS_WIN
-#   include <QOperatingSystemVersion>
-#endif
 
 /* OpenGL|ES 2.0 doesn't have those definitions */
 #ifndef GL_MAP_WRITE_BIT
@@ -82,13 +77,13 @@ OpenGLCommon::OpenGLCommon() :
     texCoordYCbCr[0] = texCoordYCbCr[4] = texCoordYCbCr[5] = texCoordYCbCr[7] = 0.0f;
     texCoordYCbCr[1] = texCoordYCbCr[3] = 1.0f;
 
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
     m_gl3 = (m_glInstance->glVer >= 30);
 #endif
 
     m_matrixChangeFn = [this] {
         setMatrix = true;
-        updateGL(true);
+        requestGLUpdate(true);
     };
 }
 OpenGLCommon::~OpenGLCommon()
@@ -124,16 +119,14 @@ void OpenGLCommon::initialize(const std::shared_ptr<OpenGLHWInterop> &hwInterop)
 
     if (hwInterop)
     {
-        QOffscreenSurface surface;
-        QOpenGLContext context;
+        // Qt4: No QOffscreenSurface/QOpenGLContext
+        // Hardware interop requires active GL context - caller must ensure this
         if (!windowContext)
         {
-            surface.create();
-            if (!context.create() || !context.makeCurrent(&surface))
-            {
-                isOK = false;
-                return;
-            }
+            // Cannot create offscreen context in Qt4 easily
+            // Hardware interop will only work with active window context
+            isOK = false;
+            return;
         }
 
         switch (hwInterop->getFormat())
@@ -210,7 +203,7 @@ void OpenGLCommon::newSize(bool canUpdate)
     if (canUpdate)
     {
         if (isPaused)
-            updateGL(false);
+            requestGLUpdate(false);
         else if (!updateTimer.isActive())
             updateTimer.start(40);
     }
@@ -242,21 +235,13 @@ void OpenGLCommon::setTextureParameters(GLenum target, quint32 texture, GLint pa
 
 void OpenGLCommon::initializeGL()
 {
-    initializeOpenGLFunctions();
-
-#if !defined(QT_OPENGL_ES_2) && !defined(QT_FEATURE_opengles2)
-    if (hasPbo && !m_glInstance->hasMapBufferRange)
-    {
-        Q_ASSERT(m_glInstance->hasMapBuffer);
-        m_gl15.initializeOpenGLFunctions();
-    }
-#endif
+    // Qt4: No need to initialize GL functions explicitly
 
-    shaderProgramVideo.reset(new QOpenGLShaderProgram);
-    shaderProgramOSD.reset(new QOpenGLShaderProgram);
+    shaderProgramVideo.reset(new QGLShaderProgram);
+    shaderProgramOSD.reset(new QGLShaderProgram);
 
     /* YCbCr shader */
-    shaderProgramVideo->addShaderFromSourceCode(QOpenGLShader::Vertex, readShader(":/opengl/Video.vert"));
+    shaderProgramVideo->addShaderFromSourceCode(QGLShader::Vertex, readShader(":/opengl/Video.vert"));
     QByteArray videoFrag;
     if (numPlanes == 1)
     {
@@ -284,7 +269,7 @@ void OpenGLCommon::initializeGL()
     }
     if (target == GL_TEXTURE_RECTANGLE_ARB)
         videoFrag.prepend("#define TEXTURE_RECTANGLE\n");
-    shaderProgramVideo->addShaderFromSourceCode(QOpenGLShader::Fragment, videoFrag);
+    shaderProgramVideo->addShaderFromSourceCode(QGLShader::Fragment, videoFrag);
     if (shaderProgramVideo->bind())
     {
         texCoordYCbCrLoc = shaderProgramVideo->attributeLocation("aTexCoord");
@@ -307,8 +292,8 @@ void OpenGLCommon::initializeGL()
     }
 
     /* OSD shader */
-    shaderProgramOSD->addShaderFromSourceCode(QOpenGLShader::Vertex, readShader(":/opengl/OSD.vert"));
-    shaderProgramOSD->addShaderFromSourceCode(QOpenGLShader::Fragment, readShader(":/opengl/OSD.frag"));
+    shaderProgramOSD->addShaderFromSourceCode(QGLShader::Vertex, readShader(":/opengl/OSD.vert"));
+    shaderProgramOSD->addShaderFromSourceCode(QGLShader::Fragment, readShader(":/opengl/OSD.frag"));
     if (shaderProgramOSD->bind())
     {
         texCoordOSDLoc = shaderProgramOSD->attributeLocation("aTexCoord");
@@ -466,11 +451,13 @@ void OpenGLCommon::paintGL()
                 {
                     glBindBuffer(GL_PIXEL_UNPACK_BUFFER, pbo[p + 1]);
                     quint8 *dst = nullptr;
+#if !defined(QT_OPENGL_ES_2) && !defined(QT_FEATURE_opengles2)
+    #if !defined(Q_OS_MAC)
                     if (m_glInstance->hasMapBufferRange)
                         dst = (quint8 *)glMapBufferRange(GL_PIXEL_UNPACK_BUFFER, 0, w * h * bytesMultiplier, GL_MAP_WRITE_BIT | GL_MAP_INVALIDATE_BUFFER_BIT);
-#if !defined(QT_OPENGL_ES_2) && !defined(QT_FEATURE_opengles2)
                     else
-                        dst = (quint8 *)m_gl15.glMapBuffer(GL_PIXEL_UNPACK_BUFFER, GL_WRITE_ONLY);
+    #endif
+                        dst = (quint8 *)::glMapBuffer(GL_PIXEL_UNPACK_BUFFER, GL_WRITE_ONLY);
 #endif
                     if (!dst)
                         glBindBuffer(GL_PIXEL_UNPACK_BUFFER, 0);
@@ -642,11 +629,13 @@ void OpenGLCommon::paintGL()
                 if (hasNewSize)
                     glBufferData(GL_PIXEL_UNPACK_BUFFER, dataSize, nullptr, GL_DYNAMIC_DRAW);
                 quint8 *dst = nullptr;
+#if !defined(QT_OPENGL_ES_2) && !defined(QT_FEATURE_opengles2)
+    #if !defined(Q_OS_MAC)
                 if (m_glInstance->hasMapBufferRange)
                     dst = (quint8 *)glMapBufferRange(GL_PIXEL_UNPACK_BUFFER, 0, dataSize, GL_MAP_WRITE_BIT | GL_MAP_INVALIDATE_BUFFER_BIT);
-#if !defined(QT_OPENGL_ES_2) && !defined(QT_FEATURE_opengles2)
                 else
-                    dst = (quint8 *)m_gl15.glMapBuffer(GL_PIXEL_UNPACK_BUFFER, GL_WRITE_ONLY);
+    #endif
+                    dst = (quint8 *)::glMapBuffer(GL_PIXEL_UNPACK_BUFFER, GL_WRITE_ONLY);
 #endif
                 if (!dst)
                     glBindBuffer(GL_PIXEL_UNPACK_BUFFER, 0);
@@ -726,8 +715,16 @@ QByteArray OpenGLCommon::readShader(const QString &fileName, bool pure)
             shader = "precision highp float;\n";
         shader.append("#line 1\n");
     }
+#if QT_VERSION >= QT_VERSION_CHECK(5, 15, 0)
     const auto data = res.uncompressedData();
     shader.append(data.constData(), data.size());
+#else
+    // Qt4: No uncompressedData(), use data() which returns const uchar*
+    const uchar *data = res.data();
+    const int size = res.size();
+    if (data && size > 0)
+        shader.append(reinterpret_cast<const char*>(data), size);
+#endif
     return shader;
 }
 
diff --git a/src/qmplay2/opengl/OpenGLCommon.hpp b/src/qmplay2/opengl/OpenGLCommon.hpp
index fd3393b7..d5a6903d 100644
--- a/src/qmplay2/opengl/OpenGLCommon.hpp
+++ b/src/qmplay2/opengl/OpenGLCommon.hpp
@@ -19,17 +19,15 @@
 #pragma once
 
 #include "OpenGLInstance.hpp"
+#include "Qt4OpenGLCompat.hpp"
 
 #include <Frame.hpp>
 #include <VideoAdjustment.hpp>
 #include <VideoOutputCommon.hpp>
 #include <QMPlay2OSD.hpp>
 
-#include <QOpenGLShaderProgram>
-#if !defined(QT_OPENGL_ES_2) && !defined(QT_FEATURE_opengles2)
-#   include <QOpenGLFunctions_1_5>
-#endif
-#include <QOpenGLExtraFunctions>
+#include <QtOpenGL/QGLShaderProgram>
+#include <OpenGL/gl.h>
 
 #include <QCoreApplication>
 #include <QImage>
@@ -37,7 +35,7 @@
 
 class OpenGLHWInterop;
 
-class OpenGLCommon : public VideoOutputCommon, public QOpenGLExtraFunctions
+class OpenGLCommon : public VideoOutputCommon
 {
     Q_DECLARE_TR_FUNCTIONS(OpenGLCommon)
 
@@ -67,7 +65,7 @@ public:
     void initialize(const std::shared_ptr<OpenGLHWInterop> &hwInterop);
 
     virtual void setVSync(bool enable) = 0;
-    virtual void updateGL(bool requestDelayed) = 0;
+    virtual void requestGLUpdate(bool requestDelayed) = 0;
 
 #ifdef Q_OS_WIN
     void setWindowsBypassCompositor(bool bypassCompositor);
@@ -76,7 +74,7 @@ public:
     void newSize(bool canUpdate);
     void clearImg();
 
-    bool setSphericalView(bool spherical) override;
+    bool setSphericalView(bool spherical);
 protected:
     void setTextureParameters(GLenum target, quint32 texture, GLint param);
 
@@ -85,13 +83,9 @@ protected:
 
     void contextAboutToBeDestroyed();
 
-#if !defined(QT_OPENGL_ES_2) && !defined(QT_FEATURE_opengles2)
-    QOpenGLFunctions_1_5 m_gl15;
-#endif
-
     bool vSync;
 
-    void dispatchEvent(QEvent *e, QObject *p) override;
+    void dispatchEvent(QEvent *e, QObject *p);
 private:
     inline bool isRotate90() const;
 
@@ -114,7 +108,7 @@ public:
     int m_depth = 8;
     bool m_limited = false;
 
-    std::unique_ptr<QOpenGLShaderProgram> shaderProgramVideo, shaderProgramOSD;
+    std::unique_ptr<QGLShaderProgram> shaderProgramVideo, shaderProgramOSD;
 
     qint32 texCoordYCbCrLoc, positionYCbCrLoc, texCoordOSDLoc, positionOSDLoc;
     VideoAdjustment videoAdjustment;
diff --git a/src/qmplay2/opengl/OpenGLInstance.cpp b/src/qmplay2/opengl/OpenGLInstance.cpp
index e8cef552..96102785 100644
--- a/src/qmplay2/opengl/OpenGLInstance.cpp
+++ b/src/qmplay2/opengl/OpenGLInstance.cpp
@@ -1,57 +1,107 @@
 #include "OpenGLInstance.hpp"
 #include "OpenGLWriter.hpp"
 
-#include <QOffscreenSurface>
-#include <QOpenGLFunctions>
+#include <QtOpenGL/QGLWidget>
+#include <QtOpenGL/QGLFormat>
+#include <QtOpenGL/QGLContext>
+#include <OpenGL/gl.h>
+#include <QString>
 #include <QSet>
 
 bool OpenGLInstance::init()
 {
-    QOffscreenSurface surface;
-    QOpenGLContext context;
+    // Qt4: Need an active GL context to query
+    // Create a temporary context if needed
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+    QGLWidget *tempWidget = nullptr;
+    const QGLContext *existingContext = QGLContext::currentContext();
+    if (!existingContext)
+    {
+        // Create temporary offscreen widget to get a context
+        QGLFormat format;
+        format.setVersion(2, 0);
+        tempWidget = new QGLWidget(format);
+
+        // Ensure context is created - on some platforms we need this
+        if (!tempWidget->isValid())
+        {
+            delete tempWidget;
+            return false;
+        }
+
+        tempWidget->makeCurrent();
+
+        // Verify context is now current
+        if (!QGLContext::currentContext())
+        {
+            delete tempWidget;
+            return false;
+        }
+    }
+#endif
 
-    surface.create();
-    if (!context.create() || !context.makeCurrent(&surface))
+    // Get OpenGL version
+    const char *versionStr = (const char *)glGetString(GL_VERSION);
+    if (!versionStr)
+    {
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+        delete tempWidget;
+#endif
         return false;
+    }
 
-    auto fns = context.functions();
+    // Parse version string (e.g., "2.1 ..." or "3.0 ...")
+    int majorVersion = 2;
+    int minorVersion = 0;
+    if (versionStr[0] >= '0' && versionStr[0] <= '9')
+    {
+        majorVersion = versionStr[0] - '0';
+        if (versionStr[1] == '.' && versionStr[2] >= '0' && versionStr[2] <= '9')
+            minorVersion = versionStr[2] - '0';
+    }
 
-    if (!fns->hasOpenGLFeature(QOpenGLFunctions::Multitexture))
-        return false;
+    // Check for OpenGL ES
+    const char *rendererStr = (const char *)glGetString(GL_RENDERER);
+    isGLES = (rendererStr && strstr(rendererStr, "OpenGL ES"));
 
-    if (!fns->hasOpenGLFeature(QOpenGLFunctions::Shaders))
-        return false;
+    // Get extensions string
+    const char *extensionsStr = (const char *)glGetString(GL_EXTENSIONS);
+    QString extensions = extensionsStr ? QString::fromLatin1(extensionsStr) : QString();
+    QSet<QString> extensionSet;
+    if (!extensions.isEmpty())
+    {
+        foreach (const QString &ext, extensions.split(' ', QString::SkipEmptyParts))
+            extensionSet.insert(ext);
+    }
 
-    if (!fns->hasOpenGLFeature(QOpenGLFunctions::NPOTTextures))
+    // OpenGL 2.0 has multitexture, shaders, and NPOT built-in
+    if (majorVersion < 2)
         return false;
 
-    isGLES = context.isOpenGLES();
-
-    const auto extensions = context.extensions();
-    const auto majorVersion = context.format().majorVersion();
+    // Check for RG texture formats (OpenGL 3.0+)
+    canUse16bitTexture = (majorVersion >= 3) || extensionSet.contains("GL_ARB_texture_rg");
 
-    if (fns->hasOpenGLFeature(QOpenGLFunctions::TextureRGFormats))
-    {
-        canUse16bitTexture = (isGLES ? extensions.contains("GL_EXT_texture_norm16") : (majorVersion >= 3));
-    }
+    // VBO support (OpenGL 2.0+)
+    hasVbo = (majorVersion >= 2) || extensionSet.contains("GL_ARB_vertex_buffer_object");
 
-    hasVbo = (majorVersion >= 2 || extensions.contains("GL_ARB_vertex_buffer_object"));
     if (hasVbo)
     {
-        if (!isGLES)
-            hasMapBufferRange = extensions.contains("GL_ARB_map_buffer_range");
-        else if (majorVersion >= 3)
-            hasMapBufferRange = true;
-
-        hasMapBuffer = extensions.contains("GL_OES_mapbuffer");
-        if (Q_UNLIKELY(!isGLES && !hasMapBuffer))
-            hasMapBuffer = (majorVersion >= 2);
-
-        hasPbo = (hasMapBuffer || hasMapBufferRange) && (majorVersion >= (isGLES ? 3 : 2) || extensions.contains("GL_ARB_pixel_buffer_object"));
+        hasMapBufferRange = extensionSet.contains("GL_ARB_map_buffer_range");
+        hasMapBuffer = (majorVersion >= 2) || extensionSet.contains("GL_OES_mapbuffer");
+        hasPbo = (hasMapBuffer || hasMapBufferRange) &&
+                 ((majorVersion >= 2) || extensionSet.contains("GL_ARB_pixel_buffer_object"));
     }
 
-#ifndef Q_OS_MACOS // On macOS I have always OpenGL 2.1...
-    glVer = majorVersion * 10 + context.format().minorVersion();
+#ifndef Q_OS_MAC
+    glVer = majorVersion * 10 + minorVersion;
+#else
+    // macOS 10.6.8 has OpenGL 2.0/2.1
+    glVer = 20;
+#endif
+
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+    // Clean up temporary widget
+    delete tempWidget;
 #endif
 
     return true;
diff --git a/src/qmplay2/opengl/OpenGLInstance.hpp b/src/qmplay2/opengl/OpenGLInstance.hpp
index 759ec31a..a64fe6c6 100644
--- a/src/qmplay2/opengl/OpenGLInstance.hpp
+++ b/src/qmplay2/opengl/OpenGLInstance.hpp
@@ -20,16 +20,16 @@
 
 #include <GPUInstance.hpp>
 
-class OpenGLInstance final : public GPUInstance
+class OpenGLInstance : public GPUInstance
 {
 public:
     bool init();
 
 public:
-    QString name() const override;
-    QMPlay2CoreClass::Renderer renderer() const override;
+    QString name() const;
+    QMPlay2CoreClass::Renderer renderer() const;
 
-    VideoWriter *createOrGetVideoOutput() override;
+    VideoWriter *createOrGetVideoOutput();
 
 public:
     bool isGLES = false;
diff --git a/src/qmplay2/opengl/OpenGLWidget.cpp b/src/qmplay2/opengl/OpenGLWidget.cpp
index f7a7da05..84a945d2 100644
--- a/src/qmplay2/opengl/OpenGLWidget.cpp
+++ b/src/qmplay2/opengl/OpenGLWidget.cpp
@@ -18,12 +18,11 @@
 
 #include "OpenGLWidget.hpp"
 
-#include <QOpenGLContext>
-
 OpenGLWidget::OpenGLWidget()
 {
     m_widget = this;
     connect(&updateTimer, SIGNAL(timeout()), this, SLOT(update()));
+    connect(&m_rotAnimation, SIGNAL(valueChanged(QVariant)), this, SLOT(onRotValueUpdated(QVariant)));
 }
 OpenGLWidget::~OpenGLWidget()
 {
@@ -48,7 +47,7 @@ void OpenGLWidget::setVSync(bool enable)
     Q_UNUSED(enable)
     // Not supported
 }
-void OpenGLWidget::updateGL(bool requestDelayed)
+void OpenGLWidget::requestGLUpdate(bool requestDelayed)
 {
     if (requestDelayed)
         QMetaObject::invokeMethod(this, "update", Qt::QueuedConnection);
@@ -58,7 +57,10 @@ void OpenGLWidget::updateGL(bool requestDelayed)
 
 void OpenGLWidget::initializeGL()
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     connect(context(), SIGNAL(aboutToBeDestroyed()), this, SLOT(aboutToBeDestroyed()), Qt::DirectConnection);
+#endif
+    // Qt4: QGLContext doesn't emit aboutToBeDestroyed(), cleanup happens in destructor
     OpenGLCommon::initializeGL();
 }
 void OpenGLWidget::paintGL()
@@ -74,8 +76,13 @@ void OpenGLWidget::aboutToBeDestroyed()
     doneCurrent();
 }
 
+void OpenGLWidget::onRotValueUpdated(const QVariant &value)
+{
+    rotValueUpdated(value);
+}
+
 bool OpenGLWidget::event(QEvent *e)
 {
     dispatchEvent(e, parent());
-    return QOpenGLWidget::event(e);
+    return QGLWidget::event(e);
 }
diff --git a/src/qmplay2/opengl/OpenGLWidget.hpp b/src/qmplay2/opengl/OpenGLWidget.hpp
index 43503855..4c41a5a4 100644
--- a/src/qmplay2/opengl/OpenGLWidget.hpp
+++ b/src/qmplay2/opengl/OpenGLWidget.hpp
@@ -20,26 +20,26 @@
 
 #include "OpenGLCommon.hpp"
 
-#include <QSurfaceFormat>
-#include <QOpenGLWidget>
+#include <QtOpenGL/QGLWidget>
 
-class OpenGLWidget final : public QOpenGLWidget, public OpenGLCommon
+class OpenGLWidget : public QGLWidget, public OpenGLCommon
 {
     Q_OBJECT
 public:
     OpenGLWidget();
     ~OpenGLWidget();
 
-    bool makeContextCurrent() override;
-    void doneContextCurrent() override;
+    bool makeContextCurrent();
+    void doneContextCurrent();
 
-    void setVSync(bool enable) override;
-    void updateGL(bool requestDelayed) override;
+    void setVSync(bool enable);
+    void requestGLUpdate(bool requestDelayed);
 
-    void initializeGL() override;
-    void paintGL() override;
+    void initializeGL();
+    void paintGL();
 private slots:
     void aboutToBeDestroyed();
+    void onRotValueUpdated(const QVariant &value);
 private:
-    bool event(QEvent *e) override;
+    bool event(QEvent *e);
 };
diff --git a/src/qmplay2/opengl/OpenGLWindow.cpp b/src/qmplay2/opengl/OpenGLWindow.cpp
index b44399ac..1c9c4b78 100644
--- a/src/qmplay2/opengl/OpenGLWindow.cpp
+++ b/src/qmplay2/opengl/OpenGLWindow.cpp
@@ -20,29 +20,37 @@
 
 #include <QMPlay2Core.hpp>
 
-#include <QGuiApplication>
-#include <QOpenGLContext>
 #include <QDockWidget>
 
 OpenGLWindow::OpenGLWindow()
-    : m_platformName(QGuiApplication::platformName())
+    : m_platformName()
     , m_passEventsToParent(
-#if QT_VERSION >= QT_VERSION_CHECK(6, 6, 0)
-          !m_platformName.contains(QStringLiteral("wayland")) &&
-          m_platformName != QStringLiteral("windows") &&
+#ifdef Q_OS_MAC
+          true // macOS - pass events to parent
+#elif defined(Q_OS_WIN) || defined(Q_OS_ANDROID)
+          false // Windows/Android - transparent input
+#else
+          false // Linux/X11 - transparent input
 #endif
-          m_platformName != QStringLiteral("xcb") && m_platformName != QStringLiteral("android"))
+      )
 {
     connect(&updateTimer, SIGNAL(timeout()), this, SLOT(doUpdateGL()));
+    connect(&m_rotAnimation, SIGNAL(valueChanged(QVariant)), this, SLOT(onRotValueUpdated(QVariant)));
 
-    if (!m_passEventsToParent)
-        setFlags(Qt::WindowTransparentForInput);
+    // Qt4: QGLWidget is already a widget, no need for container
+    m_widget = this;
+
+#if !defined(Q_OS_MAC) && !defined(Q_OS_ANDROID)
+    setAttribute(Qt::WA_NativeWindow);
+#endif
+
+    setAcceptDrops(false);
 
-    m_widget = QWidget::createWindowContainer(this);
-    if (!m_platformName.contains(QStringLiteral("wayland")) && m_platformName != QStringLiteral("android"))
-        m_widget->setAttribute(Qt::WA_NativeWindow);
-    m_widget->installEventFilter(this);
-    m_widget->setAcceptDrops(false);
+    if (!m_passEventsToParent)
+    {
+        // Make widget transparent to input events
+        setAttribute(Qt::WA_TransparentForMouseEvents);
+    }
 
     connect(&QMPlay2Core, SIGNAL(videoDockVisible(bool)), this, SLOT(videoVisible(bool)));
 }
@@ -71,37 +79,35 @@ void OpenGLWindow::doneContextCurrent()
 
 void OpenGLWindow::setVSync(bool enable)
 {
-    QSurfaceFormat fmt = format();
-    if (!handle())
+    // Qt4: Use QGLFormat instead of QSurfaceFormat
+    QGLFormat fmt = format();
+    if (enable != fmt.swapInterval())
     {
-        fmt.setSwapBehavior(QSurfaceFormat::DoubleBuffer); //Probably it doesn't work
-        fmt.setSwapInterval(enable);
+        fmt.setSwapInterval(enable ? 1 : 0);
+        fmt.setDoubleBuffer(true);
         setFormat(fmt);
-    }
-    else if (enable != fmt.swapInterval())
-    {
-        fmt.setSwapInterval(enable);
-        destroy();
-        setFormat(fmt);
-        create();
-        setVisible(true);
+        // Qt4: May need recreation for format changes
+        // But that can cause issues, so just set for next time
     }
     vSync = enable;
 }
-void OpenGLWindow::updateGL(bool requestDelayed)
+void OpenGLWindow::requestGLUpdate(bool requestDelayed)
 {
-    if (m_visible && isExposed())
+    // Qt4: Use isVisible() instead of isExposed()
+    if (m_visible && isVisible())
         QMetaObject::invokeMethod(this, "doUpdateGL", Qt::QueuedConnection, Q_ARG(bool, requestDelayed));
 }
 
 void OpenGLWindow::initializeGL()
 {
-    connect(context(), SIGNAL(aboutToBeDestroyed()), this, SLOT(aboutToBeDestroyed()), Qt::DirectConnection);
+    // Qt4: QGLContext doesn't have aboutToBeDestroyed signal
+    // Context destruction is handled in destructor
     OpenGLCommon::initializeGL();
 }
 void OpenGLWindow::paintGL()
 {
-    if (isExposed())
+    // Qt4: Use isVisible() instead of isExposed()
+    if (isVisible())
     {
         glClear(GL_COLOR_BUFFER_BIT);
         OpenGLCommon::paintGL();
@@ -130,10 +136,15 @@ void OpenGLWindow::videoVisible(bool v)
     m_visible = v && (m_widget->visibleRegion() != QRegion() || QMPlay2Core.getVideoDock()->visibleRegion() != QRegion());
 }
 
+void OpenGLWindow::onRotValueUpdated(const QVariant &value)
+{
+    rotValueUpdated(value);
+}
+
 bool OpenGLWindow::eventFilter(QObject *o, QEvent *e)
 {
-    if (o == m_widget)
-        dispatchEvent(e, m_widget->parent());
+    // Qt4: m_widget is now this, so handle parent dispatching
+    dispatchEvent(e, parent());
     return false;
 }
 
@@ -147,7 +158,9 @@ bool OpenGLWindow::event(QEvent *e)
         case QEvent::MouseMove:
         case QEvent::FocusIn:
         case QEvent::FocusOut:
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         case QEvent::FocusAboutToChange:
+#endif
         case QEvent::Enter:
         case QEvent::Leave:
         case QEvent::TabletMove:
@@ -158,8 +171,10 @@ bool OpenGLWindow::event(QEvent *e)
         case QEvent::TouchBegin:
         case QEvent::TouchUpdate:
         case QEvent::TouchEnd:
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         case QEvent::InputMethodQuery:
         case QEvent::TouchCancel:
+#endif
             if (m_passEventsToParent)
                 return QCoreApplication::sendEvent(parent(), e);
         case QEvent::Wheel:
@@ -168,5 +183,5 @@ bool OpenGLWindow::event(QEvent *e)
         default:
             break;
     }
-    return QOpenGLWindow::event(e);
+    return QGLWidget::event(e);
 }
diff --git a/src/qmplay2/opengl/OpenGLWindow.hpp b/src/qmplay2/opengl/OpenGLWindow.hpp
index b61ab6e4..574da766 100644
--- a/src/qmplay2/opengl/OpenGLWindow.hpp
+++ b/src/qmplay2/opengl/OpenGLWindow.hpp
@@ -20,34 +20,36 @@
 
 #include "OpenGLCommon.hpp"
 
-#include <QOpenGLWindow>
+#include <QtOpenGL/QGLWidget>
 
-class OpenGLWindow final : private QOpenGLWindow, public OpenGLCommon
+// Qt4: No QOpenGLWindow, use QGLWidget
+class OpenGLWindow : public QGLWidget, public OpenGLCommon
 {
     Q_OBJECT
 public:
     OpenGLWindow();
     ~OpenGLWindow();
 
-    void deleteMe() override;
+    void deleteMe();
 
-    bool makeContextCurrent() override;
-    void doneContextCurrent() override;
+    bool makeContextCurrent();
+    void doneContextCurrent();
 
-    void setVSync(bool enable) override;
-    void updateGL(bool requestDelayed) override;
+    void setVSync(bool enable);
+    void requestGLUpdate(bool requestDelayed);
 
-    void initializeGL() override;
-    void paintGL() override;
+    void initializeGL();
+    void paintGL();
 
 private slots:
     void doUpdateGL(bool queued = false);
     void aboutToBeDestroyed();
     void videoVisible(bool v);
+    void onRotValueUpdated(const QVariant &value);
 private:
-    bool eventFilter(QObject *o, QEvent *e) override;
+    bool eventFilter(QObject *o, QEvent *e);
 
-    bool event(QEvent *e) override;
+    bool event(QEvent *e);
 
 private:
     const QString m_platformName;
diff --git a/src/qmplay2/opengl/OpenGLWriter.cpp b/src/qmplay2/opengl/OpenGLWriter.cpp
index 3b1afd50..b9e35e96 100644
--- a/src/qmplay2/opengl/OpenGLWriter.cpp
+++ b/src/qmplay2/opengl/OpenGLWriter.cpp
@@ -24,7 +24,7 @@
 
 #include <Frame.hpp>
 
-#include <QGuiApplication>
+#include <QApplication>
 
 using namespace std;
 
@@ -80,12 +80,11 @@ bool OpenGLWriter::set()
     {
         m_bypassCompositor = bypassCompositor;
 
-        if (QGuiApplication::platformName() == "xcb")
-        {
-            m_drawable->setX11BypassCompositor(m_bypassCompositor);
-        }
-#ifdef Q_OS_WIN
-        else if (!m_useRtt)
+        // Qt4: Use compile-time platform detection
+#if defined(Q_WS_X11)
+        m_drawable->setX11BypassCompositor(m_bypassCompositor);
+#elif defined(Q_OS_WIN)
+        if (!m_useRtt)
         {
             doReset = true;
         }
@@ -231,7 +230,7 @@ void OpenGLWriter::writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList)
         m_drawable->doReset = true;
     }
 
-    m_drawable->updateGL(m_drawable->isSphericalView());
+    m_drawable->requestGLUpdate(m_drawable->isSphericalView());
 }
 
 void OpenGLWriter::pause()
@@ -280,7 +279,8 @@ void OpenGLWriter::addAdditionalParam(const QString &key)
 
 void OpenGLWriter::initialize(const shared_ptr<OpenGLHWInterop> &hwInterop)
 {
-    for (auto &&additionalParam : std::as_const(m_additionalParams))
+    // Qt4: No std::as_const, use const reference directly
+    foreach (const QString &additionalParam, m_additionalParams)
         removeParam(additionalParam);
     m_additionalParams.clear();
 
@@ -291,7 +291,7 @@ void OpenGLWriter::initialize(const shared_ptr<OpenGLHWInterop> &hwInterop)
     bool hasBrightness = false, hasContrast = false, hasGamma = false, hasSharpness = false;
     if (!m_drawable->videoAdjustmentKeys.isEmpty())
     {
-        for (const QString &key : std::as_const(m_drawable->videoAdjustmentKeys))
+        foreach (const QString &key, m_drawable->videoAdjustmentKeys)
         {
             if (key == "Brightness")
                 hasBrightness = true;
diff --git a/src/qmplay2/opengl/OpenGLWriter.hpp b/src/qmplay2/opengl/OpenGLWriter.hpp
index c80ca3d1..8c7c4dbb 100644
--- a/src/qmplay2/opengl/OpenGLWriter.hpp
+++ b/src/qmplay2/opengl/OpenGLWriter.hpp
@@ -27,7 +27,7 @@
 class OpenGLHWInterop;
 class OpenGLCommon;
 
-class OpenGLWriter final : public VideoWriter
+class OpenGLWriter : public VideoWriter
 {
     Q_DECLARE_TR_FUNCTIONS(OpenGLWriter)
 
@@ -35,24 +35,24 @@ public:
     OpenGLWriter();
     ~OpenGLWriter();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 
-    AVPixelFormats supportedPixelFormats() const override;
+    AVPixelFormats supportedPixelFormats() const;
 
-    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList) override;
+    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList);
 
-    void pause() override;
+    void pause();
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
-    bool setHWDecContext(const std::shared_ptr<HWDecContext> &hwDecContext) override;
-    std::shared_ptr<HWDecContext> hwDecContext() const override;
+    bool setHWDecContext(const std::shared_ptr<HWDecContext> &hwDecContext);
+    std::shared_ptr<HWDecContext> hwDecContext() const;
 
 private:
     void addAdditionalParam(const QString &key);
